--[[
	Initialization
]]
if not mind then
	mind = {
		start = {},
		save = {},
		controling = {},
		time = {},
		wepmode = {},
		delay = {}
	}
end
--[[
	Configurations
]]
--Time to control a player (in seconds)
mind.controltime = 10
--Weapon type to control a player (will not damage if mode not enabled)
mind.controlweap = 1
--Weapon mode to control a player (-1:disabled,if enabled others modes will damage and this not)
mind.controlmode = 1
--Can control team? true = yes - false = no
mind.controlteam = true
--Delay to control a player again (in seconds)
mind.controldelay = 60
--[[
	Functions
]]
addhook("attack2","mind.hook_attack2")
function mind.hook_attack2(id,mode)
	if player(id,"weapontype") == mind.controlweap then
		mind.wepmode[id] = mode
	end
end
addhook("hit","mind.hook_hit")
function mind.hook_hit(id,attacker)
	if attacker ~= 0 and player(attacker,"weapontype") == mind.controlweap then
		if mind.controling[attacker] or mind.controling[id] then
			msg2(attacker,"\169255000000You or this player is already controling a player.")
			return 1
		elseif not mind.controlteam and player(id,"team") == player(attacker,"team") then
			msg2(attacker,"\169255000000You can NOT control your team!")
			return 1
		elseif mind.delay[attacker] and mind.delay[attacker]>0 then
			msg2(attacker,"\169255000000Wait "..mind.delay[attacker].." seconds more to control a player again!")
			return 1
		end
		if mind.controlmode > -1 then
			if mind.wepmode[attacker] == mind.controlmode then
				mind.control(attacker,id)
				return 1
			end
		else
			mind.control(attacker,id)
			return 1
		end
	end
end

function mind.control(controller,control)
	parse("speedmod "..control.." -30")
	mind.controling[controller] = control
	mind.start[controller] = {x=player(controller,"x"),y=player(controller,"y")}
	mind.save[controller] = {x=player(control,"x"),y=player(control,"y")}
	mind.time[controller] = 0
	mind.delay[controller] = mind.controldelay
end
function mind.decontrol(id)
	parse("speedmod "..mind.controling[id].." 0")
	mind.controling[id] = nil
	mind.start[id] = nil
	mind.save[id] = nil
	mind.time[id] = nil
end
addhook("move","mind.hook_move")
function mind.hook_move(id,x,y,walk)
	if mind.controling[id] then
		if walk == 0 then
			parse("setpos "..id.." "..mind.start[id].x.." "..mind.start[id].y)
		else
			mind.start[id] = {x=x,y=y}
			return
		end
		local newx = (x-mind.start[id].x)+mind.save[id].x
		local newy = (y-mind.start[id].y)+mind.save[id].y
		if tile(math.floor(newx/32),math.floor(newy/32),"walkable") then
			mind.save[id] = {x=newx,y=newy}
			parse("setpos "..mind.controling[id].." "..newx.." "..newy)
		end
	end
end
addhook("second","mind.hook_second")
function mind.hook_second()
	for _,id in ipairs(player(0,"table")) do
		if mind.time[id] then
			mind.time[id] = mind.time[id]+1
			if mind.time[id] >= mind.controltime then
				mind.decontrol(id)
			end
		end
		if mind.delay[id] then
			mind.delay[id] = mind.delay[id]-1
		end
	end
end
addhook("die","mind.hook_die")
function mind.hook_die(id)
	if mind.controling[id] then
		mind.decontrol(id)
	else
		for id3,id2 in pairs(mind.controling) do
			if id2 == id then
				mind.decontrol(id3)
				break
			end
		end
	end
end
addhook("endround","mind.hook_endround")
function mind.hook_endround()
	for id in pairs(mind.controling) do
		mind.decontrol(id)
	end
end